/*  >>> this is file _MALLOC_.C
        compile it with TURBO-C in large model
============================================================================
   LSETUP v1.0 (C) 1995 Hans Lermen (lermen@elserv.ffm.fgan.de)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


============================================================================
*/

/* >>>>>>>>>>>>>>>>>> this is the malloc intercept stuff */

/* NOTE: this hairy hack intercepts all our malloc
 *       to avoid a crash on DOS systems
 *   The programs that uses it must include the file _malloc_.h
 *   at TOP ( in front of any other include file )
 *   Contents of _malloc_.h :
 *
 *   #ifndef malloc
 *   #define malloc our_malloc
 *   #define realloc our_realloc
 *   #define farmalloc our_farmalloc
 *   #define farrealloc our_farrealloc
 *   #define strdup our_strdup
 *   #endif
 */

extern void err_exit(char* string, ...);

static char outofmemtx[]="out of memory";

typedef unsigned size_t;
extern void memset(void *,int ,unsigned int);

void *cdecl our_malloc(size_t size)
{
  extern void *malloc(size_t size);
  void *p=malloc(size);
  if (!p) err_exit(outofmemtx);
#if 0
  memset(p,0,size);
#endif
  return p;
}

void *cdecl our_free(void *p)
{
  extern void *free(void *p);
  free(p);
}

void *cdecl free_(void *p)
{
}

void *cdecl our_realloc(void *block, size_t size)
{
  extern void *realloc(void *block, size_t size);
  void *p=realloc(block,size);
  if (p) return p;
  err_exit(outofmemtx);
}

void far *cdecl our_farmalloc (unsigned long nbytes)
{
  extern void *farmalloc (unsigned long nbytes);
  void *p=farmalloc(nbytes);
  if (p) return p;
  err_exit(outofmemtx);
}

void far  *cdecl our_farrealloc (void far *oldblock, unsigned long nbytes)
{
  extern void *farrealloc (void far *oldblock, unsigned long nbytes);
  void *p=farrealloc(oldblock, nbytes);
  if (p) return p;
  err_exit(outofmemtx);
}

char *cdecl our_strdup (const char *s)
{
  extern char *cdecl strdup (const char *s);
  char *p=strdup(s);
  if (p) return p;
  err_exit(outofmemtx);
}


/* <<<<<<<<<<<<<<<<<< this is the malloc intercept stuff */
