/*  >>> this is file ALLOCA.C
        compile it with TURBO-C in large model
============================================================================
   LSETUP v1.3 (C) 1995..1996 Hans Lermen (lermen@elserv.ffm.fgan.de)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


============================================================================
*/

#include "_malloc_.h" /* malloc, realloc intercept, must be placed TOP */
#include <alloc.h>

struct alloca_rec {
  struct alloca_rec *next;
  char buf[];
};

static struct alloca_rec *head=0;

void *alloca(unsigned size)
{
  struct alloca_rec *p = (void *) malloc(size+ sizeof(void *)  );
  if (!head) {
    head=p;
    p->next=0;
  }
  else {
    p->next=head;
    head=p;
  }
  return &p->buf;
}

void free_alloca()
{
  struct alloca_rec *p;
  while (head) {
    p=head;
    head=head->next;
    free(p);
  }
}
