/*  >>> this is file SETUP.C
        compile it with TURBO-C in large model
============================================================================
   LSETUP v1.3 (C) 1995..1996 Hans Lermen (lermen@elserv.ffm.fgan.de)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


============================================================================
*/

#include "_malloc_.h" /* malloc, realloc intercept, must be placed TOP */
#include <stdlib.h>
#include <alloc.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <setjmp.h>
#include <dir.h>
#include <dos.h>
#include <sys/stat.h>

#include "lvideo.h"
#include "parserd.h"
#include "setup.h"
#include "uloadlin.h"
#include "iotools.h"

extern unsigned _stklen=0x2000;

#define bounds(min,max,v)  (((v)>(max))?(max):(((v)<(min))?(min):(v)))

windowtyp *text_main_window;
windowtyp *main_header_window, *main_body_window;
#define MAIN_HEADER_WINDOW_TOP 0
#define MAIN_BODY_WINDOW_TOP 2

static jmp_buf jmp_buffer;
static can_longjmp=0;
static char err_mesg[256]="";
static char **loadlin_args=0;


int main_x,main_y;    /* current position of DOS-main window */

void err_exit(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  if (vsprintf(err_mesg, string, vars) == EOF) strcpy(err_mesg, string);
  va_end(vars);
  if (can_longjmp) {
    longjmp(jmp_buffer,1);
  }
  if (err_mesg[0]) {
    /* we must use the BIOS to print the string, because we
       may come here due to heap overflow */
    struct REGPACK r;
    unsigned char *s=(void *)err_mesg;
    while (*s) {
      if (*s == '\n') {
        r.r_ax=0x0e0d;
        r.r_bx=0;
        intr(0x10,&r);
      }
      r.r_ax=0x0e00 + *s;
      r.r_bx=0;
      intr(0x10,&r);
      s++;
    };
  }
  exit(1);
}


#if 0
void init_menus()
{
  goto_window(text_main_window);
  clrscr();
  main_header_window=createframewindow(this_screen,1,0,MAIN_HEADER_WINDOW_TOP,79,MAIN_BODY_WINDOW_TOP);
/*  goto_window(main_header_window); */
  make_window_frame(main_header_window,"Ŀٳ",0);
  main_body_window=createframewindow(this_screen,0 /*1*/,0,MAIN_BODY_WINDOW_TOP,79,24);
  make_window_frame(main_body_window,"Ĵٳ",0);
  goto_window(main_body_window);
}
#endif


#define MAX_RESTART_ARGS 5
static int  max_restart_args=0;
static char restart_args[MAX_RESTART_ARGS][80]={""};
static char *restart_argv[3+MAX_RESTART_ARGS]={0};
static char main_menu_file[80];

static void restart_ourself(char **argv)
{
  char s[80];
  int i;
  can_longjmp=0;

  if (!restart_args[max_restart_args][0]) return;
  if ((restart_args[max_restart_args][0] !='\\') && (restart_args[max_restart_args][0] !='/')) {
    strcpy(s,restart_args[max_restart_args]);
    strcpy(restart_args[max_restart_args],main_menu_file);
    for (i=strlen(restart_args[max_restart_args]); ((restart_args[max_restart_args][i] !='\\') && (restart_args[max_restart_args][i] !='/')) ; i--);
    strcpy(restart_args[max_restart_args]+i+1,s);
  }
  restart_argv[0]=argv[0];
  for (i=0; i<=max_restart_args; i++) restart_argv[i+1]=restart_args[i];
  restart_argv[i+1]=0;
	clean_up_system();
  if (execv(argv[0],restart_argv) == -1) err_exit("can't restart myself");
}



char current_dir[10]="";

void set_startup_default_drive()
{
  int d=getdisk();
  current_dir[0]='A'+d;
  current_dir[1]=':';
  current_dir[2]=0;;
}

/* >>>>>>>>>>>>>>  callback functions >>>>>>>>>>>>>>>>>>>> */
char wrongnumberp[]="wrong number of args in call";
char wrongparam[]="wrong type of args in call";
char wrongtarget_is_source[]="destination and source must not be equal in call ";
long get_default_drive(struct arglisttyp *arg)
{
  if (!arg) return 0;
  if (arg->argc !=1) err_exit("%s get_default_drive",wrongnumberp);
  if (set_string_by_name(arg->argv[0]->u.s,current_dir)) return 1;
  return 0;
}

char *getargstring(struct genobjecttyp *o)
{
  char *s;
  switch (o->h.kind) {
    case OBJ_ARG_ID: s=get_string_by_name(o->u.s); break;
    case OBJ_ARG_S:  s=o->u.s;  break;
    default:         s=0; break;
  }
  return s;
}

long int getarginteger(struct genobjecttyp *o)
{
  switch (o->h.kind) {
    case OBJ_ARG_I: return o->u.i;
    case OBJ_ARG_ID: {
      char *s=get_string_by_name(o->u.s);
      if (!s) return 0;
      return strtol(s,0,0);
    }
    default: return 0;
  }
}


static void setdefault_colors()
{
  struct objecttyp  *o=get_object_by_name("default_colors",OBJ_COLORS);
  static int dc[8]= {
     0x0f00,    /* normattrib */
     0x7f00,    /* inversattrib */
     0x0F00,    /* highlightattrib */
     0x0700,    /* frameattrib */
                /* below set is for MDA-screens */
     0x0700,    /* normattrib */
     0x7000,    /* inversattrib */
     0x0F00,    /* highlightattrib */
     0x0700     /* frameattrib */
  };
  int i;
  if (o) {
    struct arglisttyp *arg=o->obj;
    if (arg) {
      for (i=0; ( (i<5) && (i<arg->argc) ); i++) {
        dc[i]=getarginteger(arg->argv[i]) << 8;
      }
    }
  }
  if (mono_screen) i=4;
  else i=0;
  set_global_attributes(this_screen,dc[i],dc[i+1],dc[i+2],dc[i+3]);
}


/* call sysinfo (sysinfolist)
   sysinfonlist = stringlist containing the following items:

   1:  current drive ("A","B","C",...)
   2:  installed RAM int units of 1KB
   3:  actual date,  format: JJJJ MM DD
   4:  actual date,  format: jjmmdd   (compareable number)
   5:  actual local time,  format: HH:MM:SS
   6:  actual local time,  format: hhmmss   (compareable number)
*/
long callback_sysinfo(struct arglisttyp *arg)
{
  enum {bufsize=1024};
  char *buf;
  struct date dt;
  struct time tm;
  static char *table[]={
    "Jan","Feb","Mar","May","Jun","Jul","Aug","Sep","Oct","Dec"
  };

  if (!arg) return 0;
  if (arg->argc !=1) err_exit("%s sysinfo",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;

  buf=malloc(bufsize);
  gettime(&tm);
  getdate(&dt);
  sprintf(buf,
    "%s\n"
    "%u\n"
    "%d %s %d\n"
    "%02d%02d%02d\n"
    "%d:%d:%d\n"
    "%02d%02d%02d\n",
    current_dir,
    get_installed_mem_from_CMOS(),
    dt.da_year,table[dt.da_mon-1],dt.da_day,
    dt.da_year-1900,dt.da_mon,dt.da_day,
    tm.ti_hour,tm.ti_min,tm.ti_sec,
    tm.ti_hour,tm.ti_min,tm.ti_sec
  );
  set_string_by_name(arg->argv[0]->u.s,buf);
/* CANDIDATE */  free(buf);
  return 1;
}

long callback_getkey(struct arglisttyp *arg)
{
  char s[2], *d;
  static char *defaultpattern="0123456789abcdefghijklmnopqrstuvwxyz\r";
  char *pattern=defaultpattern;
  int c;

  if (!arg) return 0;
  if (arg->argc <1) err_exit("%s get_default_drive",wrongnumberp);
  if (arg->argc >=2) pattern=getargstring(arg->argv[1]);
  if (!pattern) pattern=defaultpattern;
  do {
    c=l_key_input();
  } while ( (c>256) || (!strchr(pattern,tolower(c & 255))) );
  if (c=='\r') {
    d=getargstring(arg->argv[0]);
    if (d && *d) c=*d;
  }
  if ((arg->argc <3) || (!arg->argv[2]->u.i)) s[0]=c;
  else s[0]=toupper(c);
  s[1]=0;
  if (set_string_by_name(arg->argv[0]->u.s,s)) return 1;
  return 0;
}

long callback_strcat(struct arglisttyp *arg)
{
  char *d, *s, *dest;
  int ld,ls;

  if (!arg) return 0;
  if (arg->argc !=2) err_exit("%s strcat",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;
  d=get_string_by_name(arg->argv[0]->u.s);
  if (!d) return 0;

  s=getargstring(arg->argv[1]);
  if (d==s) err_exit("%s strcat",wrongtarget_is_source);
  if (!s) return 0;
  ld=strlen(d);
  ls=strlen(s);
  dest=malloc(ld+ls+1);
  memcpy(dest,d,ld);
  memcpy(dest+ld,s,ls+1);
  set_string_by_name(arg->argv[0]->u.s,dest);
  free(dest);
  return 1;
}

long callback_strcompress(struct arglisttyp *arg)
{
  char *d, *s, *dest;
  int b;

  if (!arg) return 0;
  if (arg->argc !=1) err_exit("%s strcompress",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;
  d=get_string_by_name(arg->argv[0]->u.s);
  if (!d) return 0;
  s=d=dest=strdup(d);
  while (*s == ' ') s++;
  b=0;
  while (*s) {
    if (*s == ' ') {
      if (!b) {
        *d++ = ' ';
        b=1;
      }
    }
    else {
      b=0;
      *d++ = *s;
    }
    s++;
  }
  *d=0;
  set_string_by_name(arg->argv[0]->u.s,dest);
  free(dest);
  return 1;
}

/*
 call translate(<dest>,string, codetable);
    codetable = pairs of characters
 */
long callback_translate(struct arglisttyp *arg)
{
  char *d, *s, *t, *dest;
  int i;
  char table[256];

  if (!arg) return 0;
  if (arg->argc !=3) err_exit("%s translate",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;
  d=get_string_by_name(arg->argv[0]->u.s);
  if (!d) return 0;

  s=getargstring(arg->argv[1]);
  if (d==s) err_exit("%s translate",wrongtarget_is_source);
  if (!s) return 0;
  t=getargstring(arg->argv[2]);
  if (d==t) err_exit("%s translate",wrongtarget_is_source);
  if (!t) return 0;

  for (i=0; i<256; i++) table[i]=i; /* built table */
  while (*t) {
    table[*t]=t[1];
    if (*(t++)) t++;
  }
  d=t=strdup(s);
  while (*t) {
    *t=table[*t];
    t++;
  }
  set_string_by_name(arg->argv[0]->u.s,d);
  free(d);
  return 1;
}

long callback_writetextfile(struct arglisttyp *arg)
{
  char *d, *s;
  int i;
  FILE *f;

  if (!arg) return 0;
  if (arg->argc !=2) err_exit("%s writefile",wrongnumberp);
  d=getargstring(arg->argv[0]);
  if (!d) return 0;
  s=getargstring(arg->argv[1]);
  if (d==s) err_exit("%s translate",wrongtarget_is_source);
  if (!s) return 0;
  f=fopen(d,"wt");
  if (!f) return 0;
  fprintf(f,"%s",s);
  fclose(f);
  return 1;
}

long callback_strprefix(struct arglisttyp *arg)
{
  char *d, *s, *dest;
  int ld,ls;

  if (!arg) return 0;
  if (arg->argc !=2) err_exit("%s strprefix",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;
  d=get_string_by_name(arg->argv[0]->u.s);
  if (!d) return 0;

  s=getargstring(arg->argv[1]);
  if (d==s) err_exit("%s strprefix",wrongtarget_is_source);
  if (!s) return 0;
  ld=strlen(d);
  ls=strlen(s);
  dest=malloc(ld+ls+1);
  memcpy(dest,s,ls);
  memcpy(dest+ls,d,ld+1);
  set_string_by_name(arg->argv[0]->u.s,dest);
  free(dest);
  return 1;
}


long callback_printf(struct arglisttyp *arg)
{
  enum {maxargs=16};
  char *s[maxargs];
  char *buf;
  int i;

  if (!arg) return 0;
  if ((arg->argc <1) | (arg->argc >maxargs)) err_exit("%s printf",wrongnumberp);
  for (i=0; i<arg->argc; i++) s[i]=getargstring(arg->argv[i]);
  buf=malloc(2048);
  vsprintf(buf,s[0],(va_list)(s+1));
  cputs(buf);
  free(buf);
  return 1;
}

/*
  ; call exec_loadlin(loadlinpath, arg1, arg2, ...)
 */
long callback_exec_loadlin(struct arglisttyp *arg)
{
  enum {maxargs=50};
  static char *s[maxargs];
  char *s_;
  int i,j,ret;

  if (!arg) return 0;
  if ((arg->argc <1) | (arg->argc >maxargs)) err_exit("%s exec_loadlin",wrongnumberp);
  for (i=0, j=0; i<arg->argc; i++,j++) {
    s[j]=getargstring(arg->argv[i]);
    while ((s_=strchr(s[j],'\n')) != 0) {
      s_[0]=0;
      if (s_==s[j]) break;
      s[++j]=s_+1;
    }
  }
  s[j]=0;
  if (s[0][0]==0) s[0]=_argv[0];
  ret = check_exec_loadlin(s[0]);
  if (ret) return ret;
  use_loadlin=1;
  loadlin_args=s+1;
  if (can_longjmp) {
    longjmp(jmp_buffer,2);
  }
  return 4; /* mustn't come here ! */
}


/*
  ; call restart_myself(arg1)
 */
long callback_restart_myself(struct arglisttyp *arg)
{
  char *s;
  int i;
  if (!arg) return 0;
  if (arg->argc >MAX_RESTART_ARGS) err_exit("%s restart_myself",wrongnumberp);
  max_restart_args=arg->argc-1;

  for (i=0; i<=max_restart_args; i++) {
    s=getargstring(arg->argv[i]);
    if (!s) return 0;
    strcpy(restart_args[i],s);
  }

  if (can_longjmp) {
    longjmp(jmp_buffer,3);
  }
  return 4; /* mustn't come here ! */
}


/*
  ; call driver_loaded(drivername)
 */
long callback_driver_loaded(struct arglisttyp *arg)
{
  char *s;
  if (!arg) return 0;
  if (arg->argc !=1) err_exit("%s driver_loaded",wrongnumberp);
  s=getargstring(arg->argv[0]);
  if (!s) return 0;

  if (get_driver(s)) return 1;
  return 0;
}


/*
  ; call existfile(filename)
 */
long callback_existfile(struct arglisttyp *arg)
{
  char *s;
  struct stat sb;
  if (!arg) return 0;
  if (arg->argc !=1) err_exit("%s existfile",wrongnumberp);
  s=getargstring(arg->argv[0]);
  if (!s) return 0;

  if (stat(s,&sb)) return 0;
  if (sb.st_size) return sb.st_size;
  return 1;
}


/*
  ; call checkloadlinmem(dummy)
 */
long callback_checkloadlinmem(struct arglisttyp *arg)
{
  return (check_mem_for_loadlin()==0);
}


/*
  ; call getenv(dest,envname)
 */
long callback_getenv(struct arglisttyp *arg)
{
  char *d, *s, *dest;
  int ld,ls;

  if (!arg) return 0;
  if (arg->argc !=2) err_exit("%s getenv",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;
  d=get_string_by_name(arg->argv[0]->u.s);
  if (!d) return 0;

  s=getargstring(arg->argv[1]);
  if (d==s) err_exit("%s getenv",wrongtarget_is_source);
  if (!s) return 0;

  dest=getenv(s);
  if (dest && dest[0]) {
    set_string_by_name(arg->argv[0]->u.s,dest);
    return 1;
  }
  return 0;
}




long callback_sprintf(struct arglisttyp *arg)
{
  enum {maxargs=16};
  char *s[maxargs];
  char *buf;
  char *f, *f_;
  int i;
  int c;


  if (!arg) return 0;
  if ((arg->argc <2) | (arg->argc >maxargs)) err_exit("%s sprintf",wrongnumberp);
  for (i=0; i<2; i++) s[i]=getargstring(arg->argv[i]);
  f=s[1];
  f_=f;
  for (i=2; i<arg->argc; i++) {
    s[i]=getargstring(arg->argv[i]);
    if (s[0]==s[i]) err_exit("%s sprintf",wrongtarget_is_source);

    uglyhack:
    f=strchr(f_,'%');
    if (!f) {
      break;
    }
    if ( (f[1]=='%') || (f[1]=='*') ) {
      f_=f+1;
      goto uglyhack;
    }
    f_=strpbrk(f,"diouxXfegEGcspn");
    if (!f_) break;
    switch (*f_) {
      case 'c': s[i]=(char *)s[i][0]; break;
      case 's': break;
      case 'e': case 'E': case 'f': case 'g': case 'G': {
        /* wrong at this moment, ... and wrong handled */
        break;
      }
      default: {
        /* we assume a long int here */
        s[i]=(char *)strtol(s[i],0,0);
        break;
      }
    }
  }
  buf=malloc(4096);
  vsprintf(buf,s[1],(va_list)(s+2));
  set_string_by_name(arg->argv[0]->u.s,buf);
  free(buf);
  return 1;
}

/*
  call sscanf (source,format,dest1,dest2,...)
*/
long callback_sscanf(struct arglisttyp *arg)
{
  enum {maxargs=16, bufsize=512};
  char *s[maxargs];
  char *t[maxargs];
  char *f, *f_, buf[80];
  int i,ret;

  if (!arg) return 0;
  if ((arg->argc <3) | (arg->argc >maxargs)) err_exit("%s sprintf",wrongnumberp);
  for (i=0; i<2; i++) s[i]=getargstring(arg->argv[i]);
  for (i=2; i<arg->argc; i++) {
    t[i]=malloc(bufsize);
    memset(t[i],0,bufsize);
  }
  vsscanf(s[0],s[1],(va_list)(t+2));
  f=s[1];
  f_=f;
  ret=1;
  for (i=2; i<arg->argc; i++) {
    int c;
    uglyhack:
    f=strchr(f_,'%');
    if (!f) {
      ret=0;
      break;
    }
    if ( (f[1]=='%') || (f[1]=='*') ) {
      f_=f+1;
      goto uglyhack;
    }
    f_=strpbrk(f,"diouxXfegEGcspn");
    if (!f_) break;
    switch (*f_) {
      case 'c':
      case 's': {
        set_string_by_name(arg->argv[i]->u.s,t[i]);
        break;
      }
      case 'e': case 'E': case 'f': case 'g': case 'G': {
        char c=f_[1];
        f_[1]=0;
        if (f_[-1] == 'l') sprintf(buf,f,*((double *)(t[i])));
        else sprintf(buf,f,*((float *)(t[i])));
        f_[1]=c;
        set_string_by_name(arg->argv[i]->u.s,buf);
        break;
      }
      default: {
        char c=f_[1];
        f_[1]=0;
        sprintf(buf,f,*((long *)(t[i])));
        f_[1]=c;
        set_string_by_name(arg->argv[i]->u.s,buf);
        break;
      }
    }
  }
  for (i=2; i<arg->argc; i++) free(t[i]);
  return ret;
}

long callback_stringequal(struct arglisttyp *arg)
{
  char *s1,*s2;

  if (!arg) return 0;
  if (arg->argc !=2) err_exit("%s stringequal",wrongnumberp);
  s1=getargstring(arg->argv[0]);
  if (!s1) return 0;
  s2=getargstring(arg->argv[1]);
  if (!s2) return 0;
  if (strcmp(s1,s2)) return 0;
  return 1;
}


/*
  call numbercmp(what_compare,arg1,arg2)
  where is:
     what_compare    "=" or "==" or "!=" or "<" or ">" or "<=" or ">="
     arg1,arg2       expressions or strings containing numbers
 */
long callback_numbercmp(struct arglisttyp *arg)
{
  char *cmp, *p;
  long n1,n2;
  static char table[] = "=  == != <  >  <= >= ";
                  /*     0..1..2..3..4..5..6..*/
  if (!arg) return 0;
  if (arg->argc !=3) err_exit("%s numbercmp",wrongnumberp);
  cmp=getargstring(arg->argv[0]);
  if (!cmp) return 0;
  n1=getarginteger(arg->argv[1]);
  n2=getarginteger(arg->argv[2]);

  p=strstr(table,cmp);
  if (!p) return 0;
  switch ((p - table) / 3) {
    case  0:
    case  1: return (n1 == n2);
    case  2: return (n1 != n2);
    case  3: return (n1 <  n2);
    case  4: return (n1 >  n2);
    case  5: return (n1 <= n2);
    case  6: return (n1 >= n2);
    default: return 0;
  }
}

static int jump_to_return_point=0;

/*
  call return(returnval [,dest,source] )
  where is:
    returnval   = the integer value that the function must return
    dest,source = strings, dest will be set with source
 */
long callback_return(struct arglisttyp *arg)
{
  char *s;
  if (!arg) return 0;
  if (arg->argc >3) err_exit("%s return",wrongnumberp);
  if (arg->argc >2) {
    if (arg->argv[1]->h.kind != OBJ_ARG_ID) err_exit("%s return",wrongparam);
    s=getargstring(arg->argv[2]);
    if (s) {
      set_string_by_name(arg->argv[1]->u.s,s);
    }
  }
  jump_to_return_point=1;
  return getarginteger(arg->argv[0]);
}

long callback_showfile(struct arglisttyp *arg)
{
  FILE *f;
  char buf[1024];
  char *file;

  if (!arg) return 0;
  file=getargstring(arg->argv[0]);
  f=fopen(file,"r");
  if (!f) {
    return 0;
  }
  while (fgets(buf,sizeof(buf),f)) {
    cputs_words(buf,2);
  }
  fclose(f);
  return 1;
}

long callback_exit(struct arglisttyp *arg)
{
  char *errtx=0;
  if (arg) {
    if (arg->argc >0) errtx=getargstring(arg->argv[0]);
  }
  err_exit(errtx);
  return 0; /* clumbsy, doesn't come here */
}


long callback_buttons(struct arglisttyp *arg)
{
  char *list, **list_;
  int ret;
  windowtyp *w;

  if (!arg) return 0;
  if (arg->argc !=1) err_exit("%s buttons",wrongnumberp);
  list=getargstring(arg->argv[0]);
  if (!list) return 0;

  w=current_window;
  goto_window(this_main_window);
  list_=make_stringlist(list,0,1);
  ret=cmenu_button_input(list_, w->x1-1, w->y2-3, w->x2+1, w->y2+1, "Ĵٳ",0,0);
  free(list_);
  goto_window(w);
  return ret;
}


/*  ;     number of bottom lines----v   v--- optional list of lines for the "history"
    call enterstring (resultstring, 1, templatelist)
    ;                 ^----to this inputted (or modified) result is copied
    ;                      (at input the contents of resultstring are
    ;                       offered to user to be modified )
*/
long callback_enterstring(struct arglisttyp *arg)
{
  char *list="", **list_, *template;
  int savedNL,lcount, menulines=1;
  windowtyp *w;
  char *buf, buf0;

  if (!arg) return 0;
  switch (arg->argc) {
    case 3: {
      list=getargstring(arg->argv[2]);
      /* fall through */
    }
    case 2: {
      menulines=getarginteger(arg->argv[1]);
      if (!menulines) menulines=1;
      break;
    }
    case 1: break;
    default: err_exit("%s enterstring",wrongnumberp);
  }
  template=getargstring(arg->argv[0]);
  if (!template) return 0;

  w=current_window;
  list_=make_stringlist(list,0,1);
  lcount=_get_list_length(list_);
  savedNL= replace_stringlist_terminator(list_, lcount, 0);
  buf=malloc(512);
  cmenu_line_input(buf,template,list_,
    w->x1-1, bounds(w->y1, w->y2, w->y2 -menulines),
    w->x2+1, w->y2+1, "Ĵٳ",0
  );
  replace_stringlist_terminator(list_, lcount, savedNL);
  set_string_by_name(arg->argv[0]->u.s,buf);
  free(list_);
  buf0=buf[0];
  free(buf);
  if (buf0) return 1;
  return 0;
}


long callback_system(struct arglisttyp *arg)
{
  windowtyp *w, *w_, *m;
  char *command;
  int x,y, ret;

  if (!arg) return 0;
  switch (arg->argc) {
    case 1: {
      command=getargstring(arg->argv[0]);
      if (!command) return 0;
      break;
    }
    default: err_exit("%s system",wrongnumberp);
  }

  w=current_window;
  wherexy(&x,&y);
  m=text_main_window;
  w_=createwindow(this_screen,0, m->x1, m->y1, m->x2, m->y2);
  save_window_image(w_);

  goto_window(text_main_window);
  restore_window_image(text_main_window);
  gotoxy(main_x,main_y);

  ret=system(command);

  wherexy(&main_x,&main_y);
  save_window_image(text_main_window);
  goto_window(w_);
  restore_window_image(w_);
  goto_window(w);
  free_window(w_);
  gotoxy(x,y);
  if (ret) return 0;
  if (ret <0) return 255;
  return ret;
}


/*;                     +------name of input file
  ;                     |       +-- drive letter of floppy (e.g. "A")
  ;                     |       |      +-- format for printf like "Can't determine number of sectors/track.\n"
  ;                     |       |      |
  ; callint disk_rawrite(fname, drive, nsects_ft, errio_ft, THS_ft, done_ft);
  ;                                                     |        |      |
  ; ... for printf like "Disk IO-error, status %2x\n" --+        |      |
  ; ... for printf like "Track: %02d  Head: %2d Sector: %2d\r" --+      |
  ; ... for printf like "\n...done\n" ----------------------------------+ */
long callback_disk_rawrite(struct arglisttyp *arg)
{
  enum {maxargs=6};
  char *s[maxargs];
  static char *sdefault[maxargs]= {
    0,0,
    "Can't determine number of sectors/track.\n",
    "Disk IO-error, status %2x\n",
#if 0
    "Track: %02d  Head: %2d Sector: %2d\r",
#else
    "Track: %02d  Head: %2d\r", /* because we change to full track write */
#endif
    "\n...done\n"
  };
  int i;

  if (!arg) return 0;
  if ((arg->argc <2) | (arg->argc >maxargs)) err_exit("%s disk_rawrite",wrongnumberp);
  for (i=0; i<arg->argc; i++) s[i]=getargstring(arg->argv[i]);
  for (; i<maxargs; i++) s[i]=sdefault[i];
  if (!strchr("aAbB",s[1][0])) err_exit("wrong floppy drive (%c:)",s[1][0]);

  return disk_rawrite(s[0], s[1][0], s[2], s[3], s[4], s[5]);
}


static char *copy_string_array_item(char *src, int step)
{
  char *s=src-1, *d, c;
  int i;
  for (i=0; i<step; i++) {
    s=strchr(s+1,'\n');
    if (!s) break;
  }
  if (!s) return strdup(src);
  c=*s; *s=0;
  d=strdup(src);
  *s=c;
  return d;
}


long callback_strcpyitem(struct arglisttyp *arg)
{
  char *d, *s, *s_, c;
  int item,i,step=1;

  if (!arg) return 0;
  if (arg->argc <3) err_exit("%s strcpyitem",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;
  d=get_string_by_name(arg->argv[0]->u.s);
  if (!d) return 0;

  s=getargstring(arg->argv[1]);
  if (!s) return 0;
  if (d==s) err_exit("%s strcpyitem",wrongtarget_is_source);
  item=getarginteger(arg->argv[2]);
  if (!item) return 0;
  if (arg->argc >3) {
    step = getarginteger(arg->argv[3]);
    if (step < 1) return 0;
  }

  item--;
  item *=step;
  step--;
  s--;
  for (i=0; i<=item; i++) {
    s_=s+1;
    s=strchr(s+1,'\n');
    if (!s && (i<item)) return 0;
  }
  if (s) {
    if (step) {
      for (; step--; ) {
        s=strchr(s+1,'\n');
        if (!s && (step)) break;
      }
    }
    if (s) {
      c=*s; *s=0;
      d=strdup(s_);
      *s=c;
    }
    else d=strdup(s_);
  }
  else d=strdup(s_);
  set_string_by_name(arg->argv[0]->u.s,d);
  free(d);
  return 1;
}

struct scroll_callback_params {
  struct menutyp *m;
  char **list;
};


static int _callback_from_barscroll(int line, struct scroll_callback_params *p)
{
  windowtyp *w, *w_;
  char *s, c;
  w_=current_window;
  w=p->m->userdata;
  if (!w) return 0;
  goto_window(w);
  clrscr();
  s=strchr(p->list[line],'\n');
  if (s) { c=*s; *s=0; }
  cputs_words(p->list[line],2);
  if (s) *s=c;
  goto_window(w_);
  return 0;
}

/*  ;       string-array[n][3]---v             v--- menu for scroll-helps
    call scrollbar (result_list, z_kernels, 3, z_kernels_help)
    ;               ^----here the resulting array-item is copied
*/
long callback_scrollbar(struct arglisttyp *arg)
{
  char *list, **list_;
  int ret;
  windowtyp *w;
  char *dest;
  char *menu;
  cmenu_callbacktyp *callback=0;
  int  step;
  struct scroll_callback_params p={0};

  if (!arg) return 0;
  if (arg->argc <3) err_exit("%s scrollbar",wrongnumberp);
  if (arg->argv[0]->h.kind != OBJ_ARG_ID) return 0;
  dest=get_string_by_name(arg->argv[0]->u.s);
  if (!dest) return 0;
  list=getargstring(arg->argv[1]);
  if (!list) return 0;
  step=getarginteger(arg->argv[2]);
  if (!step) return 0;

  if (arg->argc >3) {
    if (arg->argv[3]->h.kind != OBJ_ARG_ID) return 0;
    menu=arg->argv[3]->u.s;
    if (!menu) return 0;
    p.m=get_object_by_name(menu, OBJ_MENU);
    if (!p.m) return 0;
    callback=(cmenu_callbacktyp *)_callback_from_barscroll;
  }

  w=current_window;
  goto_window(this_main_window);
  list_=make_stringlist(list,0,step);
  if (callback) p.list=make_stringlist(list,1,step);

  ret=cmenu_list_input(list_, w->x1, w->y1, w->x2, w->y2, w->y1, callback, &p)+1;
  if (ret) {
    /* now user has chosen, save it */
    char *s=copy_string_array_item(list_[ret-1], step);
    set_string_by_name(arg->argv[0]->u.s,s);
    free(s);
  }
  free(list_);
  if (p.list) free(p.list);
  goto_window(w);
  return ret;
}

/*
  call choicepreset(value)
  where is:
    value   = number (>=1), a subsequent call to 'buttons' or 'scrollbar'
              will position to this item, so just pressing
              ENTER will let return 'buttons' or 'scrollbar' this value.
    NOTE: This only takes effect once.
 */
long callback_choicepreset(struct arglisttyp *arg)
{
  char *s;
  long v;
  if (!arg) return 0;
  if (arg->argc != 1) err_exit("%s choicepreset",wrongnumberp);
  v=getarginteger(arg->argv[0]);
  if (v) cmenu_choice_preset=v-1;
  return v;
}


/*
  call createvar(name, s1 [,s2, ... ,sn])
  where is:
    name   = the name of the new variable (may be ID or string)
    s1..sn = substrings which get concatenated
 */
long callback_createvar(struct arglisttyp *arg)
{
  extern char *string_append(char *s1, char *s2);
  char *s,*t,*id;
  int i,ret=1;
  if (!arg) return 0;
  if (arg->argc < 2) err_exit("%s createvar",wrongnumberp);
  if (arg->argv[0]->h.kind == OBJ_ARG_ID) id= strdup(arg->argv[0]->u.s);
  else {
    id=getargstring(arg->argv[0]);
    if (!id) return 0;
  }
  t=0;
  for (i=1; i<arg->argc; i++) {
    s=getargstring(arg->argv[i]);
    if (s) {
      s=strdup(s);
      if (!t) t=string_append(s,0);
      else t=string_append(t,s);
    }
  }
  if (t) {
    if (!create_objekt(id,t,OBJ_VARSTRING)) {
      free(t); free(id);
      ret=0;
    }
  }
  return ret;
}


/*
  call savevars(filename, v1 [,v2, ... ,vn])
  where is:
    name   = name of file to which the variables are saved
    v1..vn = the variables to save
 */
long callback_savevars(struct arglisttyp *arg)
{
  char *s;
  FILE *f;
  int i;
  if (!arg) return 0;
  if (arg->argc < 2) err_exit("%s savevars",wrongnumberp);
  s=getargstring(arg->argv[0]);
  if (!s) return 0;
  f=fopen(s,"wt");
  if (!f) return 0;
  for (i=1; i<arg->argc; i++) {
    if (arg->argv[i]->h.kind == OBJ_ARG_ID) {
      s=get_string_by_name(arg->argv[i]->u.s);
      if (s) {
        fprintf(f,"%s: string {\"%s\"}\n",arg->argv[i]->u.s,s);
      }
    }
  }
  fclose(f);
  return 1;
}


/*
  call mkdir(dirname)
  where is:
    dirname = path of the directory to be created
 */
long callback_mkdir(struct arglisttyp *arg)
{
  char *s;
  struct stat sb;
  if (!arg) return 0;
  if (arg->argc !=1) err_exit("%s mkdir",wrongnumberp);
  s=getargstring(arg->argv[0]);
  if (!s) return 0;

  if (stat(s,&sb)) {
    if (mkdir(s)) return 0;
    else return 1;
  }
  else {
    if (sb.st_mode & S_IFDIR) return 1;
    else return 0;
  }
}


    /* --------------------- */

void register_all_our_callbacks()
{
  int err=0;
  err+=register_callbackfunction(get_default_drive, "get_default_drive");
  err+=register_callbackfunction(callback_getkey, "getkey");
  err+=register_callbackfunction(callback_strcat, "strcat");
  err+=register_callbackfunction(callback_stringequal, "stringequal");
  err+=register_callbackfunction(callback_showfile, "showfile");
  err+=register_callbackfunction(callback_exit, "exit");
  err+=register_callbackfunction(callback_strprefix, "strprefix");
  err+=register_callbackfunction(callback_buttons, "buttons");
  err+=register_callbackfunction(callback_scrollbar, "scrollbar");
  err+=register_callbackfunction(callback_strcpyitem, "strcpyitem");
  err+=register_callbackfunction(callback_enterstring, "enterstring");
  err+=register_callbackfunction(callback_system, "system");
  err+=register_callbackfunction(callback_disk_rawrite, "disk_rawrite");
  err+=register_callbackfunction(callback_printf, "printf");
  err+=register_callbackfunction(callback_sprintf, "sprintf");
  err+=register_callbackfunction(callback_exec_loadlin, "exec_loadlin");
  err+=register_callbackfunction(callback_numbercmp, "numbercmp");
  err+=register_callbackfunction(callback_sscanf, "sscanf");
  err+=register_callbackfunction(callback_sysinfo, "sysinfo");
  err+=register_callbackfunction(callback_return, "return");
  err+=register_callbackfunction(callback_translate, "translate");
  err+=register_callbackfunction(callback_writetextfile, "writetextfile");
  err+=register_callbackfunction(callback_restart_myself, "restart_myself");
  err+=register_callbackfunction(callback_driver_loaded, "driver_loaded");
  err+=register_callbackfunction(callback_existfile, "existfile");
  err+=register_callbackfunction(callback_checkloadlinmem, "checkloadlinmem");
  err+=register_callbackfunction(callback_getenv, "getenv");
  err+=register_callbackfunction(callback_choicepreset, "choicepreset");
  err+=register_callbackfunction(callback_createvar, "createvar");
  err+=register_callbackfunction(callback_savevars, "savevars");
  err+=register_callbackfunction(callback_mkdir, "mkdir");
  err+=register_callbackfunction(callback_strcompress, "strcompress");
  if (err) err_exit("can't register %d of our callback functions",err);
}

/* <<<<<<<<<<<<<<<<callback functions <<<<<<<<<<<<<<<<<<<< */



static const char *framepatterns[] ={
  "Ŀٳ",  /* 0 */
  "Ĵٳ",  /* 1 */
  "ĿĴ",  /* 2 */
  "",  /* 3 */
  "Ŀٳ",  /* 4 */
  "ͻͼ",  /* 5 */
  "͹ͼ",  /* 6 */
  "ͻ͹",  /* 7 */
  "ʺ",  /* 8 */
  "ͻͼ"   /* 9 */
};

#define  ARRAY_ITEMS(x) (sizeof(x)/sizeof(x[0]))


void handle_image_output(struct objecttyp *image)
{
  char *s;
  switch (image->h.kind) {
    case OBJ_ARG_S:
    case OBJ_ARG_ID: s=getargstring((struct genobjecttyp *)image); break;
    case OBJ_VARSTRING: s=(char *)image->obj; break;
    default: return;
  }
#if 1
  if (s) cputs_words(s,2);
#else
  if (s) cputs(s);
#endif
}


static void printxy(int x, int y, char *s, int attr)
{
  windowtyp *w_;
  int attr_, savedattr;
  w_=current_window;
  if (attr >=0) {
    if (attr ==0) attr_=w_->currattrib;
    else attr_=attr<<8;
  }
  else attr_=text_main_window->currattrib;
  goto_window(text_main_window);
  savedattr=text_main_window->currattrib;
  text_main_window->currattrib=attr_;
  gotoxy(x,y);
  cputs(s);
  text_main_window->currattrib=savedattr;
  goto_window(w_);
}

static struct objecttyp *get_action_label(struct objectheader **a, char *ident)
{
  while (a[0]) {
    if (!strcmp(a[0]->olabel,ident)) return (void *)a;
    a++;
  }
  return 0;
}


static long int handle_actions(struct objecttyp **alist); /* forward */

static long int do_callfunction(struct call_actiontyp *c_a)
{
  struct objecttyp *p;
  char *name;
  if (!c_a) return 0;
#if 1
  if (!strcmp(c_a->h.olabel,"mainloop")) {
    name=get_string_by_name(c_a->function);
  }
#endif

    /* we try to access indirectly  */
  name=get_string_by_name(c_a->function);
  if (!name) name=c_a->function;

    /* first we try to find a menu function */
  p=get_object_by_name(name,  OBJ_FUNCTION);
  if (p) {
    return handle_actions((void *)p->obj);
  }

    /* now we try to find a builtin (callback) function */
  p=get_object_by_name(name,  OBJ_CALLBACK);
  if (p) {
    callbackfunction *func=(void *)p->obj;
    return (*func)(c_a->arg);
  }

    /* comeing here we are giving up */
  err_exit("action or function '%s' not defined",name);
}

long int handle_actions(struct objecttyp **alist)
{
  struct objecttyp *a, **aa=alist;
  long returnval=0;
  int errorval=0;

  if (!aa) return 0;
  while (aa[0]) {
    a=aa[0];
    switch (a->h.kind) {
      case OBJ_NONE:
      case OBJ_MENU: break;
      case OBJ_SHOWACT: {
        struct show_actiontyp *show_a=(void *)a;
        struct objecttyp *act;
        if (!get_object_by_name(show_a->menuname, OBJ_MENU)) {
          /* try to get it indirectly */
          char *name=get_string_by_name(show_a->menuname);
          if (!get_object_by_name(name, OBJ_MENU))
                err_exit("ERROR: 'action show %s', menu not existing",show_a->menuname);
        }
        act=(void *)show_a->action;
        if (act) {
          if (act->h.kind == OBJ_ARG_ID) {
            act=get_object_by_name((char *)act->obj,OBJ_FUNCTION);
            if (act) act=act->obj;
          }
          else act=0;
        }
        returnval=push_window(show_a->menuname,(void *)show_a->image,(void *)act);
        break;
      }
      case OBJ_WAITKEYACT: {
        struct waitkey_actiontyp *waitk_a=(void *)a;
        if (waitk_a->possible_strokes) {
          int c;
          do {
            c=l_key_input();
          } while (c>256);
          if (strchr(waitk_a->possible_strokes,c)) returnval=1;
          else returnval=0;
        }
        else l_key_input();
        break;
      }
      case OBJ_PRINTXYACT: {
        struct genobjecttyp **arg=(void *)a->obj;
        int argc=((long *)arg)[0];
        char *s;
        int x,y,attr=-1;
        if ((argc <3) || (argc >4)) err_exit("ERROR: incorrect number of args in printxy()");
        x=getarginteger(arg[1]);
        y=getarginteger(arg[2]);
        s=arg[3]->u.s;
        if (arg[3]->h.kind==OBJ_ARG_ID) s=get_string_by_name(s);
        if (argc ==4) attr=getarginteger(arg[4]);
        if (s) printxy(x,y,s,attr);
        break;
      }

      case OBJ_SETACT: {
        struct set_actiontyp *s_a=(void *)a;
        if ((!s_a->dest && (s_a->h.flags != SET_EVALUATE)) || !s_a->src) {
          errorval=0;
          break;
        }
        switch (s_a->h.flags) {
          case SET_DIRECT: {
            if (set_string_by_name(s_a->dest,s_a->src)) errorval= 1;
            else errorval =0;
            break;
          }
          case SET_INDIRECT: {
            char *s;
            if (!strcmp(s_a->src,"__lastresult__")) {
              char buf[20];
              ltoa(returnval,buf,10);
              s=strdup(buf);
            }
            else s=get_string_by_name(s_a->src);
            if (s) {
              if (set_string_by_name(s_a->dest,s)) errorval= 1;
              else errorval =0;
            }
            else errorval =0;
            break;
          }
          case SET_EVALUATE: {
            if (single_parse(s_a->src)) errorval= 1;
            else errorval =0;
            break;
          }
        }
        break;
      }

      case OBJ_CALLACT: {
        returnval=do_callfunction((void *)a);
        if (jump_to_return_point) {
          jump_to_return_point=0;
          return returnval;
        }
        break;
      }

      case OBJ_GOTOACT: {
        struct genobjecttyp *g_a=(void *)a;
        struct objecttyp **aa_;
        int jmp;
        switch (g_a->h.flags) {
          case GOTO_NOW:        jmp=1;            break;
          case GOTO_CALL_TRUE:
          case GOTO_IF_TRUE:    jmp=returnval;    break;
          case GOTO_CALL_FALSE:
          case GOTO_IF_FALSE:   jmp= !returnval;  break;
          case GOTO_IF_TRUE | GOTO_IF_ERROR:   jmp= !errorval;  break;
          case GOTO_IF_FALSE | GOTO_IF_ERROR:  jmp= errorval;  break;
        }
        if (jmp) {
          switch (g_a->h.flags) {
            case GOTO_CALL_FALSE:
            case GOTO_CALL_TRUE: {
              returnval=do_callfunction((void *)a);
              if (jump_to_return_point) {
                jump_to_return_point=0;
                return returnval;
              }
              break;
            }
            default: {
              aa_=(void *)get_action_label((void *)alist, g_a->u.s);
              if (!aa_) err_exit("attempt to access the undefined jump label %s",g_a->u.s);
              aa=aa_-1;
            }
          }
        }
        break;
      }
    }
    aa++;
  }
  return returnval;
}

long int push_window(char *name, struct objecttyp *image, void **action)
{
  windowtyp *w, *w_;
  int withcursor=0;
  int returnval=0;
  char *framepattern;
  struct menutyp *m=get_object_by_name(name, OBJ_MENU);

  if (!m) {
    /* try to get it indirectly */
    name=get_string_by_name(name);
    m=get_object_by_name(name, OBJ_MENU);
    if (!m) return returnval;
  }

  w_=current_window;
  goto_window(text_main_window);

  w=createframewindow(this_screen, withcursor, m->x, m->y, m->x+m->xsize-1, m->y+m->ysize-1);

  if (m->frameattrib >=0) w->frameattrib=m->frameattrib<<8;
  if (m->normattrib >=0) {
    w->normattrib=m->normattrib<<8;
    w->currattrib=w->normattrib;
  }
  if (m->inversattrib >=0) w->inversattrib=m->inversattrib<<8;
  if (m->highlightattrib >=0) w->highlightattrib=m->highlightattrib<<8;

  m->userdata=(void *)w;
  save_window_image(w);
  if ( (unsigned long)m->framepattern > ARRAY_ITEMS(framepatterns) ) {
    framepattern=m->framepattern;
  }
  else framepattern=(void *)framepatterns[(long)m->framepattern];
  make_window_frame(w,framepattern,0);
  goto_window(w);
  clrscr();

  if (!image) image=m->image;
  handle_image_output(image);
  if (!action) action=m->action;
  if (action) returnval=handle_actions((void *)action);

  m->userdata=0;
  restore_window_image(w);
  goto_window(w_);
  free_window(w);
  return returnval;
}


void do_our_job()
{
  int i;

  push_window(get_startmenu_name(),0,0);

}

#if 0
static clear_heap()
{
  typedef struct {
    unsigned short opint20;
    unsigned short memend_frame;
  } dos_segprefix;
  dos_segprefix *psp=MK_FP(_psp,0);
  char *p=malloc(0x4000);
  unsigned short m,stop,size=0x0400;

  free(p);
  m=FP_SEG(p)+(FP_OFF(p)>>4)+1;
  stop=psp->memend_frame;
  while (m+size <stop) {
    p=MK_FP(m,0);
    memset(p,0,size<<4);
    m+=size;
  }
  p=MK_FP(m,0);
  memset(p,0,((stop-m)<<4)-16);
}
#endif

static define_void(char *ident)
{
  char *s=strdup("0"), *id;
  s[0]=0;
  id=strdup(ident);
  if (!create_objekt(id,s,OBJ_VARSTRING)) {
    free(id); free(s);
  }
}

int main(int argc, char **argv)
{
  int termination_mode;
  char *menu_file;
  void *some_piece_of_mem;
  int argi=1;
  int verbose=0;

#if 1
  while (argv[argi] && (argv[argi][0] == '-') ) {
    switch (argv[argi][1]) {
      case 'v': verbose=1; break;
      case 'D': define_void(argv[argi]+2); break;
    }
    argi++;
  }
#else
  if (argv[argi]) {
    if (!strcmp(argv[argi],"-v")) {
      verbose=1;
      argi++;
    }
  }
#endif

  if (argv[argi]) menu_file = argv[argi];
  else {
    menu_file=strdup(argv[0]);
    strcpy(menu_file+(strlen(menu_file)-4),".MNU");
  }
  fxpand(main_menu_file, menu_file, ".MNU");

  /* we need some piece of heap to free in case we get heapoverflow
     and we want to use printf to put the message out */
  some_piece_of_mem=malloc(1024+1024);

  if (parse_menu(main_menu_file)) {
    fprintf(stderr,"error on parsing menu-file %s\n",menu_file);
    exit(1);
  }
  register_all_our_callbacks();
  set_startup_default_drive();

  initvideo();
  setdefault_colors();

  wherexy(&main_x,&main_y);
  text_main_window=this_main_window;
  save_window_image(text_main_window);

  if ((termination_mode=setjmp(jmp_buffer)) == 0) {
    can_longjmp=1;
    do_our_job();
  }
  else can_longjmp=-1;

  goto_window(text_main_window);
  restore_window_image(text_main_window);
  gotoxy(main_x,main_y);

  free(some_piece_of_mem);

  if (verbose) printf("free memory: %d Kb\n",coreleft()/1024);

  if (err_mesg[0]) fprintf(stderr,"\n%s\n",err_mesg);
  switch (termination_mode) {
    case 0: {
      /* we came here without error */
      exit(0);
    }
    case 1: {
      /* we came here with error */
      exit(1);
    }
    case 2: {
      /* we came here to start loadlin */
      #if 0
      use_loadlin=0;
      #endif
      exec_loadlin(loadlin_executable_path,loadlin_args);
      exit(1); /* mustn't come here ! */
    }
    case 3: {
      /* we came here to restart ourself */
      restart_ourself(argv);
    }
  }
  return 1;
}
